//           findfiles.cxx
//  Copyright  2007  Álvaro Morais
//  <alvarommorais@gmail.com>

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Library General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor Boston, MA 02110-1301,  USA

#include "findfiles.h"


FindFiles::FindFiles(string _path = "./", bool _recursive = true) : recursive(_recursive)
{
	path = _path;	
}

void FindFiles::Start()
{
	RealStart(path);	
}

void FindFiles::RealStart(string _path)
{
	DIR *dp;
	struct dirent *ep;
	string fullname;
	string filename;
	string path_t = IncludeTrailingBackslash(_path);
	
	struct stat buf;
	
	  
	dp = opendir (_path.c_str());
	if (dp != NULL)
	{
		while (ep = readdir (dp))
		{
			filename = ep->d_name;
			
			if ( filename != "." && filename != "..")
			{
				fullname = path_t + filename;
				
				cout << fullname << endl;
				stat(fullname.c_str(), &buf);
				if(S_ISDIR(buf.st_mode))
				{
					RealStart(fullname);
				}
				
			}
		}
		closedir (dp);
	}

	
}

string FindFiles::IncludeTrailingBackslash(string _path) 
{
	int sz = _path.length();
	if(sz)
	{
		if(_path[sz-1] != '/')
			_path += "/";
		return _path;
	}
	return NULL;
}

string FindFiles::ExcludeTrailingBackslash(string _path)
{
	int sz = _path.length();
	if(sz)
	{

		while(_path[--sz] == '/');
			_path= _path.substr(0,sz+1);
		return _path;
	}
	return NULL;
}
